go的错误日志

webyh · · 3265 次点击 · · 开始浏览    
这是一个创建于 的文章,其中的信息可能已经有所发展或是发生改变。
package main

import (
	"fmt"
	"log"
	"os"
)

func self_logger(myerr interface{}) {
	logfile, err := os.OpenFile("d:/golang/log/test.log", os.O_CREATE|os.O_APPEND|os.O_RDWR, 0)
	if err != nil {
		fmt.Printf("%s\r\n", err.Error())
		os.Exit(-1)
	}
	defer logfile.Close()
	logger := log.New(logfile, "\r\n", log.Ldate|log.Ltime|log.Llongfile)
	logger.Println(myerr)

}

func main() {
	defer func() { // 必须要先声明defer,否则不能捕获到panic异常
		fmt.Println("c")
		if err := recover(); err != nil {
			self_logger(err) // 这里的err其实就是panic传入的内容,55
		}
		fmt.Println("d")
	}()
	f()
}

func f() {
	fmt.Println("a")
	panic(55)
	fmt.Println("b")
	fmt.Println("f")
}
执行结果:
a
c
d

错误日志文件输出内容:
2015/07/24 14:18:10 D:/golang/project/time.go:17: 55 
时间+目录+错误信息

panic会中断程序执行,一般我们程序里面有错误,如除以0等等会自动触发panic

panic执行完后,并不是立马结束程序,还能提交到defer上执行,可以通过recover捕捉错误,但是程序不会执行panic后面

的语句咯

总结:go的defer使用起来真方便,设计的好处是错误处理不需要自己加一大堆try catch做错误流程处理



有疑问加站长微信联系(非本文作者)

本文来自:开源中国博客

感谢作者:webyh

查看原文:go的错误日志

入群交流(和以上内容无关):加入Go大咖交流群,或添加微信:liuxiaoyan-s 备注:入群;或加QQ群:1006366459

3265 次点击  
加入收藏 微博
暂无回复
添加一条新回复 (您需要 登录 后才能回复 没有账号 ?)
  • 请尽量让自己的回复能够对别人有帮助
  • 支持 Markdown 格式, **粗体**、~~删除线~~、`单行代码`
  • 支持 @ 本站用户;支持表情(输入 : 提示),见 Emoji cheat sheet
  • 图片支持拖拽、截图粘贴等方式上传